#include "gg_file_selector.h"

gg_file_selector::gg_file_selector(_file_ok_handler ok_callback_func,
                                   void *ok_callback_data)
{

    this->ok_callback_func = ok_callback_func;
    this->ok_callback_data = ok_callback_data;

    widget = gtk_file_selection_new("Open GAMESS File");

    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(widget)->ok_button),
                       "clicked", GTK_SIGNAL_FUNC(handler_ok), (gpointer) this);

    /* Ensure that the dialog box is destroyed when the user clicks a button. */

    gtk_signal_connect(GTK_OBJECT(widget), "destroy",
                       (GtkSignalFunc) handler_destroy, (gpointer) this);
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(widget)->ok_button),
                              "clicked", GTK_SIGNAL_FUNC(gtk_object_destroy),
                              GTK_OBJECT(widget));

    gtk_signal_connect_object(GTK_OBJECT
                              (GTK_FILE_SELECTION(widget)->cancel_button),
                              "clicked", GTK_SIGNAL_FUNC(gtk_object_destroy),
                              GTK_OBJECT(widget));

    /* Display that dialog */

    gtk_widget_show(widget);
    gtk_window_set_modal((GtkWindow *) widget, TRUE);

}

void gg_file_selector::handler_destroy(GtkWidget * parent, gpointer data)
{
    gg_file_selector *selector = (gg_file_selector *) data;
    delete selector;
}

void gg_file_selector::handler_ok(GtkObject * object, gpointer data)
{

    gchar *selected_filename;

    gg_file_selector *selector = (gg_file_selector *) data;

    selected_filename =
        (gchar *) gtk_file_selection_get_filename((GtkFileSelection *)
                                                  selector->widget);

    if (selected_filename != NULL)
    {
        selector->ok(selected_filename);
    }

    // printf("Opening: %s\n", selected_filename);

    // selector->parent->new_task((char *) selected_filename);
    // free(selected_filename);

}

void gg_file_selector::ok(char *filename)
{

    (*ok_callback_func) (filename, ok_callback_data);
}

gg_file_selector::~gg_file_selector(void)
{
}
