#ifndef GG_MAIN_WINDOW_H
#define GG_MAIN_WINDOW_H

#include <glade/glade.h>
#include <gtk/gtk.h>
#include <sys/types.h>

/* socket includes */
#include <sys/socket.h>
#include <sys/un.h>

/* try taking this out since we're not using fifos anymore */
//#include <sys/stat.h>

#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>
#include <glib.h>
#include <errno.h>

#include "gg_config.h"
#include "gg_file_selector.h"
#include "gg_task.h"
#include "gg_preferences_window.h"

#include "defines.h"

class gg_main_window {
  protected:
    GladeXML * xml;
    GtkWidget *widget;
    GtkWidget *list;
    GtkWidget *statusbar;
    GtkTreeModel *list_model;
    gg_config *config;

    /* char *fifo_path; */
    int server_socket;
    int max_socket;
    char *socket_path;
    fd_set socket_set;

    /* int fifo; */
    GtkTreeIter current_iter;
    int num_tasks;

    char *get_filename_prefix(char *);

  public:
      gg_main_window(gg_config *);
     ~gg_main_window(void);

    static void handler_destroy(GtkWidget *, gpointer);

    static void handler_exit(GtkWidget *, gpointer);
    void destroy_window();

    static void handler_file(char *, void *);
    void file(char *);

    static void handler_preferences(GtkWidget *, gpointer);
    void preferences();

    static void handler_add(GtkWidget *, gpointer);
    void open_file();

    static void handler_start(GtkWidget *, gpointer);
    void start_next_task();
    void start(gg_task *);

    static void handler_stop(GtkWidget *, gpointer);
    void stop_current_task();
    void stop(gg_task *);

    static void handler_requeue(GtkWidget *, gpointer);
    void requeue();

    static void handler_remove(GtkWidget *, gpointer);
    void remove();

    void msg_error(char *);
    void msg_warn(char *);

    /*
       static void handler_select_row(GtkTreeView *, gboolean , gpointer );
       void select_row();
     */

    static gboolean handler_child_timer(gpointer);
    gboolean child_timer();

};


#endif // GG_MAIN_WINDOW_H
