#ifndef GG_PREFERENCE_WINDOW_H
#define GG_PREFERENCE_WINDOW_H

#include <glade/glade.h>
#include <gtk/gtk.h>
#include <gtk/gtk.h>

#include <config.h>

#include "gg_config.h"
#include "gg_file_selector.h"

#include "defines.h"

class gg_preferences_window {
  protected:
    GladeXML * xml;
    GtkWidget *widget;
    gg_config *config;

  public:
      gg_preferences_window(gg_config *);
     ~gg_preferences_window();

    static void handler_executable(GtkWidget *, gpointer);
    static void handler_browse_executable(char *, void *);
    void browse_executable(char *);

    static void handler_scratch(GtkWidget *, gpointer);
    static void handler_browse_scratch(char *, void *);
    void browse_scratch(char *);

    static void handler_data(GtkWidget *, gpointer);
    static void handler_browse_data(char *, void *);
    void browse_data(char *);

    static void handler_save(GtkWidget *, gpointer);
    void save();

    static void handler_destroy(GtkWidget *, gpointer);

    static void handler_cancel(GtkWidget *, gpointer);
    void cancel();


};

#endif // GG_PREFERENCE_WINDOW_H
