
#include "gg_main_window.h"
#include "gg_config.h"
#include "defines.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <string.h>
#include <errno.h>
using namespace std;


int main(int argc, char **argv)
{

    gg_main_window *main;
    gg_config *config;

    int client_socket, garbage_size = 3, i;
    struct sockaddr_un socket_address;
    char *socket_path, garbage[garbage_size];
    int socket_flags;

    /* try to open the socket */

    if ((client_socket = socket(AF_UNIX, SOCK_STREAM, 0)) == -1)
    {
        perror("Cannot Create Server Socket");
        exit(2);
    }

    socket_flags = fcntl(client_socket, F_GETFL);
    /* we do not need the client to be non-blocking and don't want it to be */

    /* fcntl( client_socket, F_SETFL, socket_flags | O_NONBLOCK ); */

    socket_path =
        g_strconcat(g_get_tmp_dir(), "/", PACKAGE_NAME, "-", g_get_user_name(),
                    NULL);

    if ((sizeof(char) * strlen(socket_path)) >
        (sizeof(socket_address.sun_path) - 1))
    {
        printf
            ("Socket file path is too long please update your temp directory location:\n%s\n",
             socket_path);
        exit(3);
    }

    bzero(&socket_address, sizeof(socket_address));
    socket_address.sun_family = AF_UNIX;
    strcpy(socket_address.sun_path, socket_path);
#ifdef HAVE_SOCKADDR_UN_SUN_LEN
    /* not sure what to set this to, thinking it doesn't matter */
    /* socket_address.sun_len = strlen(socket_address.sun_path); */
    socket_address.sun_len = SUN_LEN(&socket_address);
#endif

    free(socket_path);

    if (connect
        (client_socket, (struct sockaddr *) &socket_address,
         SUN_LEN(&socket_address)) != -1)
    {
        printf("%s Is Already Running.\n", APP_NAME);
        if (argc > 1)
        {
            printf("Passing Arguments to Already Running Process.\n");
        }
        for (i = 1; i < argc; i++)
        {
            /* buffer cheking */
            if ((strlen(argv[i]) + 2) <= BUFFSIZE)
            {
                write(client_socket, argv[i], strlen(argv[i]) + 1);
                /* write( fifo, "\t", 1); */
            }
        }

        /* 
         * this is a fix for Cygwin as for some reason their sockets will close and
         * lose the buffer.  I'm guessing its some winsock error
         */

        read(client_socket, garbage, garbage_size);

        close(client_socket);
        return 0;
    }

    close(client_socket);

    printf("Starting %s\n", APP_NAME);

    config = new gg_config();

    gtk_init(&argc, &argv);
    glade_init();

    main = new gg_main_window(config);

    for (i = 1; i < argc; i++)
    {
        /* buffer cheking */
        if ((strlen(argv[i]) + 2) <= BUFFSIZE)
        {
            main->file(argv[i]);
        }
    }


    gtk_main();

    delete(config);
    delete(main);

    return 0;
}
